package com.brilliance.isc.funds.common.controller;


import com.brilliance.isc.common.api.settle.controller.AbstractSettleDetailController;
import com.brilliance.isc.common.api.settle.vo.AccountRequestVo;
import com.brilliance.isc.common.api.settle.vo.AccountResponseVo;
import com.brilliance.isc.common.api.settle.vo.SettleDetailRequestVo;
import com.brilliance.isc.common.api.settle.vo.SettleDetailResponseVo;
import com.brilliance.isc.common.setgll.vo.SetgllVo;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.funds.FtdBizAmdInfoVo;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 账务组件
 */
@RestController
@RequestMapping("/ftd")
public class FtdSettleDetailController extends AbstractSettleDetailController<FtdBizInfoVo, FtdBizAmdInfoVo> {

    /**
     * 试算账务入口
     *
     * @param settleDetailRequestVo
     * @return
     */

    @RequestMapping("/setmod/calcSettleDetail")
    @Override
    public ResponseSet<SettleDetailResponseVo> calcSettleDetail(@RequestBody SettleDetailRequestVo<FtdBizInfoVo, FtdBizAmdInfoVo> settleDetailRequestVo) {
        return super.calcSettleDetail(settleDetailRequestVo);
    }

    /**
     * 获取核心账户信息
     *
     * @param accountRequestVo
     * @return
     */

    @RequestMapping("/getCoreAcctInfo")
    @Override
    public ResponseSet<AccountResponseVo> getCoreAccountCode(@RequestBody AccountRequestVo accountRequestVo) {
        return super.getCoreAccountCode(accountRequestVo);
    }

    /**
     * 获取账户信息
     *
     * @param setgllVo
     * @return
     */

    @RequestMapping("/getAcctInfo")
    @Override
    public ResponseSet<SetgllVo> getAcctInfo(@RequestBody SetgllVo setgllVo) {
        return super.getAcctInfo(setgllVo);
    }
}
