package com.brilliance.isc.funds.common.register.cci;

import com.brilliance.isc.bo.Cci;
import com.brilliance.isc.bo.Pts;
import com.brilliance.isc.common.register.cci.CliBanInfo;
import com.brilliance.isc.common.transaction.help.TransactionHelpService;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.mda.dao.PtsMapper;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Component("FXD.cciRegister")
public class FxdCliBanInfo implements CliBanInfo {

    @Resource
    private TransactionHelpService transactionHelpService;
    @Resource
    private PtsMapper ptsMapper;

    /**
     * source:fxdlod.0006.script
     */
    @Override
    public void buildValue(String objinr, String objtyp, List<PtsptaVo> ptsptaVos, Cci cci) {
        //getFxdCliBanInfo
        List<Pts> ptsList = ptsMapper.getPtsByObjInrTyp(objinr, objtyp);
        if (CollectionUtils.isEmpty(ptsList)) {
            ptsList = new ArrayList<>();
            for (PtsptaVo ptsptaVo : ptsptaVos) {
                ptsList.add(ptsptaVo.getPts());
            }
        }
        if (CollectionUtils.isEmpty(ptsList)) {
            return;
        }

        //! Defines role of the bank and the customer of the passed contract and PTAINR of the role as well
        //! The passed contract has to be loaded completely
        // role can be set dynamically dependent on the contract context
        cci.setCcicusrol("APL");
        Optional<Pts> optionalPts = ptsList.stream().filter(pts -> cci.getCcicusrol().equalsIgnoreCase(pts.getRol())).findFirst();
        if (optionalPts.isPresent()) {
            cci.setCcicusptainr(optionalPts.get().getPtainr());
        }
        cci.setCcibanptainr("");
        cci.setCcibanrol("");
    }
}
