package com.brilliance.isc.funds.fttfcm.resource;

import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.bo.funds.FttfcmStoreBo;
import com.brilliance.isc.funds.fttfcm.service.FttfcmTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FttfcmStructMapper;
import com.brilliance.isc.funds.vo.funds.FttfcmStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtfopStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FttfcmResource
 * @description: 结售汇平盘确认 Fttfcm 请求入口
 * @author: xiaotong
 * @create: 2024-10-11 17:09
 */

@RestController
@RequestMapping("/fttfcm")
public class FttfcmResource extends AbstractTransactionController<FttfcmStoreVo> {

    @Resource
    private FttfcmStructMapper fttfcmStructMapper;

    public IStructMapper getStructMapper() {
        return fttfcmStructMapper;
    }

    @Resource
    FttfcmTransactionServiceImpl fttfcmTransactionService;


    /**
     * 根据结售汇类型 等获取业务参号
     *
     * @param FttfcmStoreVo
     * @return
     */
    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody FttfcmStoreVo fttfcmStoreVo) {
        String ref = fttfcmTransactionService.getRef(fttfcmStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }


}
