package com.brilliance.isc.funds.fttfcn.check;

import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;
import com.brilliance.isc.common.transaction.newcheck.Validate;
import com.brilliance.isc.funds.bo.funds.FttfcnStoreBo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

import static com.brilliance.mda.runtime.mda.Constants.PanStaAdd;
import static com.brilliance.mda.runtime.mda.Constants.PanStaEdit;

/**
 * @program: isc-funds
 * @ClassName: FttfcnValidator
 * @description: 结售汇平盘确认 fttfcn 校验
 * @author: 肖桐
 * @create: 2024-10-11 11:28
 */
@Component
public class FttfcnValidator extends AbstractModuleValidator <FttfcnStoreBo>{

    @Override
    @PostConstruct
    public void register(){
        super.register();;
    }

    @Override
    public Map<String, String> validate(FttfcnStoreBo vo) {
        Map<String, String> maps = new HashMap<>();
        maps.putAll(super.validate(vo));
        return maps;
    }






    /**
     *   source:fttfcn.0022.script
     */
    @Validate(path="canamt")
    public ValidResult checkFtdgrpCbsInsAmtN1000(FttfcnStoreBo bo){


        if (bo.getCanamt().compareTo(bo.getFtdgrp().getCbs().getOpn2().getAmt())>0 ) {
            return ValidResult.build(false, "实际销账金额不能大于待销账金额！");
        }
        return null;
    }


}
