package com.brilliance.isc.funds.fttpcn.check;



import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;import com.brilliance.isc.common.transaction.newcheck.Validate;import com.brilliance.isc.funds.bo.funds.FttfcnStoreBo;import com.brilliance.isc.funds.bo.funds.FttpcnStoreBo;
import org.springframework.stereotype.Component;
import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;



@Component
public class FttpcnValidator extends  AbstractModuleValidator<FttpcnStoreBo>{

       @Override
        @PostConstruct
        public void register() {
            super.register();
        }

        @Override
        public Map<String, String> validate(FttpcnStoreBo bo) {
            Map<String, String> maps = new HashMap<>();
            maps.putAll(super.validate(bo));
            return maps;
        }
        @Validate(path="canamt")
        public ValidResult checkCanamtN1000(FttpcnStoreBo bo){
            if (bo.getCanamt().compareTo(bo.getFtdgrp().getCbs().getOpn2().getAmt())>0 ) {
                    return ValidResult.build(false, "实际销账金额不能大于待销账金额！");
                }
                return null;
            }
}
