package com.brilliance.isc.funds.fttpcn.register.settle;


import com.brilliance.isc.bo.model.Ftdgrp;import com.brilliance.isc.common.register.settle.DefaultSettleRegister;import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;import com.brilliance.isc.vo.funds.FtdBizInfoVo;import org.springframework.beans.factory.annotation.Autowired;import org.springframework.stereotype.Component;


@Component("fttpcn.settleRegister")
public class FttpcnSettleRegister implements ISettleRegister{

     @Autowired
     private SetmodService setmodService;
     @Autowired
     private SetglgService setglgService;
     @Autowired
     private DefaultSettleRegister defaultSettleRegister;
     @Autowired
     private FtToolComponent ftToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
         transRegister(setmodVo);
         defaultSettleRegister.registerSettlement(setmodVo);
    }
     private void transRegister(SetmodVo setmodVo) {

       FtdBizInfoVo rec = (FtdBizInfoVo) setmodVo.getRec();
       Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(rec.getObjinr());
       setmodVo.setDocamt(rec.getCanamt());
       setmodVo.setDoccur(ftdgrp.getCbs().getMax().getCur());
       SetglgVo setglg = setmodVo.getSetglg();
       setglgService.setglgClrAmount ( setglg,"TRN" );
       String dbtKey = setglgService.setglgAddAmount(setglg,"TRN","TRI",
                         setmodVo.getDoccur(),rec.getCanamt(),"", "DBD","C","","");

       String cdtKey = setglgService.setglgAddAmount(setglg,"TRN","OWN",
                         setmodVo.getDoccur(),setmodVo.getDocamt(),"","FTC","C","","");
     }

}
