package com.brilliance.isc.funds.fxtfcm.register.settle;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fxtfcm.settleRegister")
public class FxtfcmSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;


    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private FxToolComponent fxToolComponent;

    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();

        Fxdgrp fxdgrp = fxToolComponent.getFxdgrpByInr(rec.getObjinr());

        String maxCur=NULLSTR;
        BigDecimal maxAmt = BigDecimal.ZERO;
        String nom1Cur = NULLSTR;
        BigDecimal nom1Amt = BigDecimal.ZERO;

        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
            maxCur= setmodVo.getCbsMap().get("MAX").getCur();
        }

        if (setmodVo.getCbsMap().get("NOM1") != null) {
            nom1Amt = setmodVo.getCbsMap().get("NOM1").getAmt();
            nom1Cur= setmodVo.getCbsMap().get("NOM1").getCur();
        }

        setmodVo.setDoccur(maxCur);
        setmodVo.setDocamt(maxAmt);
        setmodVo.setOpnamt(maxAmt);

        SetglgVo setglg = setmodVo.getSetglg();

        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"TRN" );
        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"SET" );
        //!==============================================
        //2、付出外币资金：
        //借：281105外汇买卖对外平盘   （A外币）
        //贷：112306/1125存放境内/外同业  （A外币）
        //!==============================================
        String act1 = null;
        String dbtKey = null;
        String acctyp = null;
        String acc = null;
        String cdtKey = null;
        BigDecimal baseunit = null;
        if(  ! MdaUtils.isEmpty(rec.getFxtyp()) )
        {
            //#卖出确认
            //D:281105(A外币)
            act1 = glemodService.getAvailAcc ( "FX-SPR", nom1Cur, "", setmodVo.getSetamt() );
            dbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "APL", maxCur, setmodVo.getSetamt(), "SET", "FTD", "F", act1, "SET" );
            /**
             $Act1 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-ELQ", FXDGRP\\CBS\\MAX\\CUR, "", self, SETMOD\\SETAMT )
             $DbtKey = \\SETMOD\\SETGLG.SetglgAddAmount ( "SET", "OWN", SETMOD\\DOCCUR, SETMOD\\SETAMT, "SET", "FXD", "F", $Act1, "SET" )

             **/
            // cz modify 增加中间中间账户

            if( ptsptaToolComponent.ptsIsRolSet(fxdgrp.getAct()) )
            {
                if( ptsptaToolComponent.IsDemestic(fxdgrp.getAct()) )
                {
                    acctyp = "DB-CLR";
                    acc = glemodService.getAvailAcc ( acctyp,maxCur, fxdgrp.getAct().getPts().getPtyinr(),  setmodVo.getSetamt() );
                    cdtKey =setglgService.setglgAddAmount ( setglg,"SET", "APL", maxCur, setmodVo.getSetamt().negate(), "", "DBC", "C", acc, "" );
                }
                else
                {
                    acctyp = "DB-FOG";
                    acc = glemodService.getAvailAcc ( acctyp, maxCur, fxdgrp.getAct().getPts().getPtyinr(), setmodVo.getSetamt() );
                    cdtKey = setglgService.setglgAddAmount (setglg, "SET", "APL", maxCur, setmodVo.getSetamt().negate(), "", "PAC", "C", acc, "" );
                }
            }
            else
            {
                if( ptsptaToolComponent.IsDemestic(fxdgrp.getApl()) )
                {
                    acctyp = "DB-CLR";
                    acc = glemodService.getAvailAcc ( acctyp, maxCur, fxdgrp.getApl().getPts().getPtyinr(),  setmodVo.getSetamt() );
                    cdtKey = setglgService.setglgAddAmount ( setglg,"SET", "APL", maxCur, setmodVo.getSetamt().negate(), "", "DBC", "C", acc, "" );
                }
                else
                {
                    acctyp = "DB-FOG";
                    acc = glemodService.getAvailAcc ( acctyp, maxCur, fxdgrp.getApl().getPts().getPtyinr(),  setmodVo.getSetamt() );
                    cdtKey = setglgService.setglgAddAmount ( setglg,"SET", "APL", maxCur, setmodVo.getSetamt().negate(), "", "PAC", "C", acc, "" );
                }
            }
            //C:112306/1125外币
            //如果ACT未赋值，则APL为我行的账户行
            setglgService.setglgAddAmtFldAccCur ( setmodVo.getSetglg(),"SET", dbtKey, nom1Cur );
            baseunit = xrtmodService.crossRatebas( maxCur, nom1Cur );
            setglgService.setglgAddAmtFldExtRat ( setmodVo.getSetglg(),"SET", dbtKey, Decimals.mul(1.00,baseunit), fxdgrp.getRec().getRat() );
        }
        //setglgService.setglgAllValDat ( fxdgrp.getRec().getValdat(), "D" );
        setmodService.setglgAllValDat (setmodVo,fxdgrp.getRec().getValdat(), "D" );
    }
}
