package com.brilliance.isc.funds.fxtfcm.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.bo.funds.FxtfcmStoreBo;
import com.brilliance.isc.funds.fxtfcm.service.FxtfcmTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FxtfcmStructMapper;
import com.brilliance.isc.funds.vo.funds.FxtfcmStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.funds.FttselQueryVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @program: isc-funds
 * @ClassName: FxtfcmResource
 * @description: 结售汇平盘确认 Fxtfcm 请求入口
 * @author: xiaotong
 * @create: 2024-10-11 17:09
 */

@RestController
@RequestMapping("/fxtfcm")
public class FxtfcmResource extends AbstractTransactionController<FxtfcmStoreVo> {

    @Resource
    private FxtfcmStructMapper fxtfcmStructMapper;

    public IStructMapper getStructMapper() {
        return fxtfcmStructMapper;
    }

    @Resource
    FxtfcmTransactionServiceImpl fxtfcmTransactionService;

    @Autowired
    private SettleContext settleContext;

    @PostMapping("/defaultAcc1N1000")
    public ResponseSet defaultAcc1N1000(@RequestBody FxtfcmStoreVo vo) {
        try {
            settleContext.loadSettleSession("FXTFCM","","");
            List<String> accList= fxtfcmTransactionService.defaultAcc1N1000(vo);
            return ResponseSet.simpleSuccess(accList);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }
    }

    @PostMapping("/defaultAcc2N1000")
    public ResponseSet defaultAcc2N1000(@RequestBody FxtfcmStoreVo vo) {
        try {
            settleContext.loadSettleSession("FXTFCM","","");
            List<String> accList= fxtfcmTransactionService.defaultAcc2N1000(vo);
            return ResponseSet.simpleSuccess(accList);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }
    }

}
