package com.brilliance.isc.funds.fxtfcm.service;

import com.brilliance.isc.bo.Act;
import com.brilliance.isc.bo.Fxd;
import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.bo.model.Lidgrp;
import com.brilliance.isc.common.api.bch.service.BchService;
import com.brilliance.isc.common.cache.pta.PtaCacheService;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.contants.CommonContants;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.liaall.service.LiaallService;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.transaction.help.TransactionHelpService;
import com.brilliance.isc.common.transaction.help.TransactionServiceSet;
import com.brilliance.isc.common.trnmod.service.TrnmodService;
import com.brilliance.isc.common.trnmod.vo.TrnmodVo;
import com.brilliance.isc.common.vo.BizAmdInfoVo;
import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.funds.bo.funds.FxtfcmStoreBo;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.funds.fxtfcm.check.FxtfcmValidator;
import com.brilliance.isc.funds.fxtlop.service.FxtpService;
import com.brilliance.isc.funds.vo.funds.FxtfcmStoreVo;
import com.brilliance.isc.mda.dao.PtyratMapper;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.brilliance.isc.mda.dao.ActMapper;
import com.brilliance.isc.common.component.SptDataComponent;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: FxtfcmTransactionServiceImpl
 * @description: 结售汇平盘确认 Fxtfcm 业务处理
 * @author: xiaotong
 * @create: 2024-10-11 15:20
 */

@Service("fxtfcm.transaction")
public class FxtfcmTransactionServiceImpl extends AbstractTransactionService<FxtfcmStoreBo> {
    @Resource
    private FxtfcmValidator fxtfcmValidator;
//    @Autowired
//    private FxtfcmService fxtfcmService;
    @Resource
    private FxToolComponent fxToolComponent;
    @Resource
    private TrnmodService trnmodService;
    @Resource
    private XrtmodService xrtmodService;
    @Resource
    private TransactionHelpService transactionHelpService;
    @Resource
    private CbsmodService cbsmodService;
    @Resource
    private LiaallService liaallService;
    @Resource
    private SettleContext settleContext;
    @Autowired
    private PtaCacheService ptaCacheService;

    @Resource
    private BchService bchService;



    @Resource
    private PtyratMapper ptyratMapper;

    @Resource
    private ActMapper actMapper;

    @Resource
    private SetmodService setmodService;

    @Resource
    private FxtpService fxtpService;

    @Autowired
    SptDataComponent sptDataComponent;

    @PostConstruct
    public void regisertService() {
        serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
        serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");

//        serviceRegisterMaps.put(CommonContants.UMDMOD_SERVICE, "N");
//        serviceRegisterMaps.put(CommonContants.LIMMOD_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_RMB_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_SZSB_BOPREM_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.BOPSET_CFABOP_SERVICE, "Y");
//        serviceRegisterMaps.put(CommonContants.FANXIQIAN_SERVICE, "Y");
    }

    @Override
    protected void txnSave(FxtfcmStoreBo transactionVo) {
        ruleMtabutSavN500(transactionVo);
    }

    @Override
    protected Map<String, String> txnCheck(FxtfcmStoreBo transactionVo) {
        return fxtfcmValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FxtfcmStoreBo transactionVo) {
        FxdBizInfoVo bizInfoVo = new FxdBizInfoVo();
        bizInfoVo.setObjtyp("FXD");
        Fxd rec = transactionVo.getFxdgrp().getRec();
        bizInfoVo.setObjinr(rec.getInr());
        bizInfoVo.setOwnref(rec.getOwnref());
        bizInfoVo.setFxtyp(rec.getFxtyp());
        bizInfoVo.setAcc(rec.getAcc());
        bizInfoVo.setAcc2(rec.getAcc2());
        bizInfoVo.setDsp(rec.getDsp());
        bizInfoVo.setDsp2(rec.getDsp2());
        bizInfoVo.setTrdint(rec.getTrdint());
        bizInfoVo.setTrdout(rec.getTrdout());
        bizInfoVo.setTrnman(rec.getTrnman());
        bizInfoVo.setRat(rec.getRat());
        return bizInfoVo;
    }

    @Override
    protected BizAmdInfoVo buildBizAmdInfo(FxtfcmStoreBo transactionVo) {
        return null;
    }

    @Override
    public FxtfcmStoreBo init(FxtfcmStoreBo fxtfcmStoreBo) {
        fxtfcmStoreBo.reset();
        String fxdinr = fxtfcmStoreBo.getFxdgrp().getRec().getInr();
        if (sptDataComponent.needMergeSptData(fxtfcmStoreBo)) {
            fxdinr = fxtfcmStoreBo.getSpt().getObjinr();
        }

        Fxdgrp fxdgrpVo = fxToolComponent.getFxdgrpByInr(fxdinr);
        fxtfcmStoreBo.setFxdgrp(fxdgrpVo);

        init950(fxtfcmStoreBo);
        init1000(fxtfcmStoreBo);
        return fxtfcmStoreBo;
    }

    private void init950(FxtfcmStoreBo fxtfcmStoreBo) {
    }

    private void init1000(FxtfcmStoreBo fxtfcmStoreBo) {
        String extkey = SettleContext.getUserSession().getUsr().getExtkey();
        fxtfcmStoreBo.getFxdgrp().getRec().setOwnusr(extkey);
    }

    @Override
    public void beforeSave(FxtfcmStoreBo transactionVo) {
        transactionVo.reset();
        Fxdgrp fxdgrp = transactionVo.getFxdgrp();

        TransactionServiceSet transactionServiceSet = transactionHelpService.getTransactionStoreSet();
        transactionServiceSet.setRec(fxdgrp.getRec());
        transactionServiceSet.setBlk(fxdgrp.getBlk());
        transactionServiceSet.setTransactionVo(transactionVo);
        fxToolComponent.collectCbsMap(transactionServiceSet, "", fxdgrp.getCbs(), "max", "nom1", "opn1", "opn2");
        fxToolComponent.collectPtsList(transactionServiceSet, fxdgrp, null);
        settleContext.loadSettleSession(transactionVo.getTransName(), transactionVo.getUserId(), buildBizInfo(transactionVo), transactionServiceSet.getPtsList());
    }

    @Override
    protected void updateBizInfoVo(BizInfoVo bizInfoVo, FxtfcmStoreBo transactionVo) {
        bizInfoVo.setObjinr(transactionVo.getFxdgrp().getRec().getInr());
    }

    public void ruleMtabutSavN500(FxtfcmStoreBo bo) {
        TrnmodVo trnmodVo = transactionHelpService.getTransactionStoreSet().getTrnmodVo();

        fxToolComponent.getref(bo.getFxdgrp());
        // 1. Create (rsp. update) Contract (incl. Texts)
        bo.getFxdgrp().getRec().setCnfdat( Dates.today());
        if( MdaUtils.compareTo(bo.getFxdgrp().getCbs().getOpn2().getAmt(),0) == 0 )
        {
            bo.getFxdgrp().getRec().setClsdat( Dates.today());
        }
        bo.getFxdgrp().setAcc(bo.getAplacc());
        fxToolComponent.sav(bo.getFxdgrp(), BigDecimal.ZERO);
        // 2. Build Transaction from FTDGRP
        trnmodService.trnSetFromContract ( trnmodVo);
        cbsSav(bo,trnmodVo);
        // save documents
        //TODO
        //记录116台账
        //transactionVo.getNosmod().savNostro();
    }

    public void cbsSav(FxtfcmStoreBo transactionVo, TrnmodVo trnmodVo) {
        cbsmodService.cbsTrnSetNew("TRN",trnmodVo.getTrn().getInr());

        //liaallService.storeAll(transactionHelpService.getTransactionStoreSet().getLiaall());
        cbsmodService.cbsTrnCommit();
    }






    public List<String> defaultAcc2N1000(FxtfcmStoreVo vo){
        vo.reset();
        Fxd rec=vo.getFxdgrp().getRec();

        List<String> actLst=new ArrayList<>();
        if( ! MdaUtils.isEmpty(vo.getFxdgrp().getCbs().getMax().getCur()) && ! MdaUtils.isEmpty(vo.getAplacc().getPts().getPtyinr()) )
        {
            String sql = "WHERE CUR = '" + vo.getFxdgrp().getCbs().getMax().getCur() + "' AND SERPTYINR = '" + vo.getAplacc().getPts().getPtyinr() + "' AND TYP = 'DB'";
            actLst = actMapper.getSerAccByConditionSql(sql);

            if( ! vo.isModified("acc2") && actLst.size()>0) {
                vo.setAcc2( actLst.get(0));
            }
        }
        else
        {
            vo.setAcc2(NULLSTR);
        }


        return actLst;
    }

    /**
     *   source:fxtfcm.0009.script
     */

    public  List<String> defaultAcc1N1000(FxtfcmStoreVo vo){
        vo.reset();
        Fxd rec=vo.getFxdgrp().getRec();

        List<String> actLst=new ArrayList<>();
        if( ! MdaUtils.isEmpty(vo.getFxdgrp().getCbs().getMax().getCur()) && ! MdaUtils.isEmpty(vo.getFxdgrp().getAct().getPts().getPtyinr()) )
        {
            String sql = "WHERE CUR = '" + vo.getFxdgrp().getCbs().getMax().getCur() + "' AND SERPTYINR = '" + vo.getFxdgrp().getAct().getPts().getPtyinr() + "' AND TYP = 'DB'";
            actLst = actMapper.getSerAccByConditionSql(sql);

            if( ! vo.isModified("acc1") && actLst.size()>0) {
                vo.setAcc1( actLst.get(0));
            }
        }
        else
        {
            vo.setAcc1(NULLSTR);
        }


        return actLst;
    }
}
