package com.brilliance.isc.funds.fxtfop.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.fxtfop.service.FxtfopTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FxtfopStructMapper;
import com.brilliance.isc.funds.vo.funds.FxtfopStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtssbStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FxtfopResource
 * @description: 即期结汇 Fxtfop 请求入口
 * @author: huangshunlin
 * @create: 2024-10-08 15:34
 */
@RestController
@RequestMapping("/fxtfop")
@Api("外币兑换登记")
public class FxtfopResource extends AbstractTransactionController<FxtfopStoreVo> {

    @Resource
    private FxtfopStructMapper fxtfopStructMapper;

    public IStructMapper getStructMapper() {
        return fxtfopStructMapper;
    }

    @Resource(name = "fxtfop.transaction")
    FxtfopTransactionServiceImpl fxtfopTransactionService;

    @Autowired
    private SettleContext settleContext;
    /**
     * 根据结售汇类型 等获取业务参号
     *
     * @param fxtfopStoreVo
     * @return
     */
    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody FxtfopStoreVo fxtfopStoreVo) {
        String ref = fxtfopTransactionService.getRef(fxtfopStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }


    @PostMapping("/defaultRateN1000")
    public ResponseSet defaultRateN1000(@RequestBody FxtfopStoreVo fxtfopStoreVo) {
        try {
            settleContext.loadSettleSession("FXTFOP","","");
            fxtfopTransactionService.defaultRateN1000(fxtfopStoreVo);
            return ResponseSet.simpleSuccess(fxtfopStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }

    @PostMapping("/defaultCalculateN1100")
    public ResponseSet defaultCalculateN1100(@RequestBody FxtfopStoreVo fxtfopStoreVo) {
        try {
            settleContext.loadSettleSession("FXTFOP","","");
            fxtfopTransactionService.defaultCalculateN1100(fxtfopStoreVo);
            return ResponseSet.simpleSuccess(fxtfopStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }

}
