package com.brilliance.isc.funds.fxtlcm.document;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.trndoc.vo.DoceotVo;
import com.brilliance.isc.funds.bo.funds.FxtlcmStoreBo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.Formats;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @program: isc-funds
 * @ClassName: BuildFxt300s1
 * @description: 组装MT300报文
 * @author: Lenovo
 * @create: 2024-10-14 14:43
 */
@Component("fxtlcm.BuildFxt300s1")
public class BuildFxt300s1 {

    public Map<String, Object> build(FxtlcmStoreBo trnBo, DoceotVo doceotVo) {
        HashMap map = new HashMap();
        map.putAll(printHeader(trnBo, doceotVo));
        //map.putAll(printBody(trnBo, doceotVo));
        map.putAll(printFooter(trnBo, doceotVo));
        return map;
    }


    private Map<String, Object> printHeader(FxtlcmStoreBo trnBo, DoceotVo doceotVo) {
        HashMap<String, Object> map = new HashMap<>();
        String title = "";
        title = "   Formatted outgoing  message  /  mt300 Viewer";
        map.put("title", title);
        return map;
    }

    private Map<String, Object> printFooter(FxtlcmStoreBo trnBo, DoceotVo doceotVo) {
        HashMap<String, Object> map = new HashMap<>();
        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        String format = sdf.format(new Date());
        String footer = Strings.getText("Diary  printed by $1 on $2 at $3 during the change",
                SettleContext.getUserSession().getUsr().getExtkey(), Formats.fmtDateLong(Dates.today()), format);
        map.put("footer", footer);
        return map;
    }
}
