package com.brilliance.isc.funds.fxtlcm.register.doc;

import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.register.document.IDocumentRegister;
import com.brilliance.isc.common.register.document.common.SetmodDocumentRegister;
import com.brilliance.isc.common.trndoc.service.TrndocService;
import com.brilliance.isc.common.trndoc.vo.TrndocVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FxtlcmDocumentRegister
 * @description: 结售汇平盘确认 Fxtlcm 报文注册
 * @author: Lenovo
 * @create: 2024-10-14 15:22
 */
@Component("fxtlcm.documentRegister")
public class FxtlcmDocumentRegister implements IDocumentRegister {

    @Autowired
    TrndocService trndocService;
    @Resource
    PtsptaToolComponent ptsptaToolComponent;

    @Autowired
    private SetmodDocumentRegister setmodDocumentRegister;


    @Override
    public void registerDocument(TrndocVo trndoc) {

        doRegister(trndoc);
        setmodDocumentRegister.registerDocument(trndoc);
    }

    public void doRegister(TrndocVo trndoc){
        FxdBizInfoVo rec = (FxdBizInfoVo) trndoc.getRec();
        PtsptaVo aplVo = ptsptaToolComponent.getPtsFromListByRol(trndoc.getPtsptas(), "APL");
        if (!MdaUtils.isEmpty(rec.getSwtflg())) {
            trndocService.defDocEot(trndoc, "TRN", "300", "\\FXT300L1", "LET", 0, aplVo.getPts().getPtainr(), "\\FXDGRP\\REC", "MT 300", "TRO", "");
        }
    }
}
