package com.brilliance.isc.funds.fxtlcn.check;

import com.brilliance.isc.bo.Act;
import com.brilliance.isc.common.transaction.newcheck.AbstractModuleValidator;
import com.brilliance.isc.common.transaction.newcheck.ValidResult;
import com.brilliance.isc.common.transaction.newcheck.Validate;
import com.brilliance.isc.common.util.Utils;
import com.brilliance.isc.funds.bo.funds.FxtlcnStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtlcnStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtfopStoreVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.stereotype.Component;


import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: FxtlcnValidator
 * @description: 结售汇平盘确认 Fxtlcn 校验
 * @author: 肖桐
 * @create: 2024-10-11 11:28
 */
@Component
public class FxtlcnValidator extends AbstractModuleValidator <FxtlcnStoreBo>{

    @Override
    @PostConstruct
    public void register(){
        super.register();;
    }

    @Override
    public Map<String, String> validate(FxtlcnStoreBo vo) {
        Map<String, String> maps = new HashMap<>();
        maps.putAll(super.validate(vo));
        return maps;
    }


    /**
     *   source:fxtlcn.0007.script
     */
    @Validate(path="canamt")
    public ValidResult checkCanamtN1000(FxtlcnStoreBo bo){
        if( "LB".equals(bo.getFxdgrp().getRec().getFxtyp()) && MdaUtils.compareTo(bo.getCanamt(),bo.getFxdgrp().getCbs().getNom1().getAmt())>0 )
        {
            return ValidResult.build(false,"实际销账金额不能大于待销账金额！");
        }
        return null;
    }

    /**
     *   source:fxtlcn.0011.script
     */
    @Validate(path="fxdgrp.act.pts.extkey")
    public ValidResult checkActN1000(FxtlcnStoreBo bo){
        if( MdaUtils.compareTo(bo.getFxdgrp().getAct().getPts().getPtyinr(),bo.getOldactinr()) != 0 )
        {
            if( MdaUtils.compareTo(bo.getOldactinr(),"NONE") == 0 && MdaUtils.isEmpty(bo.getFxdgrp().getAct().getPts().getPtyinr()) ) {
            } else
            {
                return ValidResult.build(false,"账户行不一致，无法销账!");
            }
        }

        return null;
    }

    //TODO
    //收报才会有relcur, relamt，先去除此校验
    @Validate(path="fxdgrp.cbs.nom1.amt")
    public ValidResult checkNom1AmtN1000(FxtlcnStoreBo bo){
//        if( ( MdaUtils.compareTo(bo.getRelcur(),bo.getFxdgrp().getCbs().getNom1().getCur()) != 0 || MdaUtils.compareTo(bo.getRelamt(),bo.getFxdgrp().getCbs().getNom1().getAmt()) != 0 ) )
//        {
//            return ValidResult.build(false, "金额不一致或没有绑定报文，无法销账!");
//        }
       return null;
    }

}
