package com.brilliance.isc.funds.fxtlcn.register.fee;

import com.brilliance.isc.common.register.fee.AbstractFeeRegister;
import com.brilliance.isc.common.register.fee.common.DocumentFeeRegister;
import com.brilliance.isc.common.register.fee.common.LiaallFeeRegister;
import com.brilliance.isc.common.register.fee.common.SetmodFeeRegister;
import com.brilliance.isc.common.setfeg.service.SetfegService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @program: isc-funds
 * @ClassName: FxtlcnFeeRegister
 * @description: 结售汇平盘确认 Fxtlcn 费用注册
 * @author: Lenovo
 * @create: 2024-10-11 17:36
 */

@Component("fxtlcn.feeRegister")
public class FxtlcnFeeRegister extends AbstractFeeRegister {

    @Autowired
    private SetfegService setfegService;
    @Autowired
    private DocumentFeeRegister documentFeeRegister;
    @Autowired
    private LiaallFeeRegister liaallFeeRegister;
    @Autowired
    private SetmodFeeRegister setmodFeeRegister;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        setmodFeeRegister.registerSettlement(setmodVo);
        documentFeeRegister.registerSettlement(setmodVo);
        liaallFeeRegister.registerSettlement(setmodVo);
    }

}
