package com.brilliance.isc.funds.fxtlcn.register.settle;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NO_ERROR;
import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fxtlcn.settleRegister")
public class FxtlcnSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;

    @Resource
    private SettleContext settleContext;


    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private FxToolComponent fxToolComponent;

    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();

        Fxdgrp fxdgrp = fxToolComponent.getFxdgrpByInr(rec.getObjinr());


        //取得上下文
        setmodVo.setDoccur(rec.getCancur());
        setmodVo.setDocamt(rec.getCanamt());
        SetglgVo setglg = setmodVo.getSetglg();

        setglgService.setglgClrAmount ( setglg,"TRN" );
        setglgService.setglgClrAmount ( setglg,"TRN1" );
        setglgService.setglgClrAmount ( setglg,"SET1" );
        
        //!===============================================
        //!BOOKING:
        //!买入：D: 114(或116)外币  C:13903外币
        //!卖出：13903人民币的销账在核心处理
        //!===============================================
        String dbtKey1 = NULLSTR;
        String act1 = NULLSTR;
        String cbtKey1 = NULLSTR;
        String act4 = NULLSTR;
        String dbtKey2 = NULLSTR;
        String act5 = NULLSTR;
        String cbtKey2 = NULLSTR;
        String acctyp = NULLSTR;
        String cdtKey = NULLSTR;
        String act2 = NULLSTR;
        String dbtKey = NULLSTR;
        if( MdaUtils.compareTo(Strings.mid(rec.getFxtyp(),2,1),"S") == 0 )
        {
            //! 20190529增加卖出平盘销账
            dbtKey1 =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", fxdgrp.getCbs().getNom1().getCur(), fxdgrp.getCbs().getNom1().getAmt(), "", "DTC", "C", this.getAccountByEntity(), "SET" );
            act1 = glemodService.getAvailAcc ( "FT-FCR", "CNY", "", setmodVo.getSetamt() );
            cbtKey1 =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", fxdgrp.getCbs().getNom1().getCur(), fxdgrp.getCbs().getNom1().getAmt().negate(), "", "FTD", "A", act1, "" );
            act4 = glemodService.getAvailAcc ( "FX-SLQ", "CNY", "", setmodVo.getSetamt() );
            dbtKey2 =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", fxdgrp.getCbs().getNom1().getCur(), fxdgrp.getCbs().getNom1().getAmt(), "", "FXC", "A", act4, "" );
            act5 = glemodService.getAvailAcc ( "FX-ZJJ", "CNY", "", setmodVo.getSetamt() );
            cbtKey2 =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", "CNY", fxdgrp.getCbs().getNom1().getAmt().negate(), "", "FXD", "C", act5, "" );
            
        }
        else
        {
            //如果ACT角色未赋值，则APL为我行账户行
            if( ptsptaToolComponent.ptsIsRolSet(fxdgrp.getAct()) )
            {
                //D: 114(或116)外币
                if( ptsptaToolComponent.IsDemestic( fxdgrp.getAct()) )
                {
                    acctyp = "DB-CLR";
                    act1 = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getAct().getPts().getPtyinr(), setmodVo.getSetamt() );
                    cdtKey =setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act1, "" );
                }
                else
                {
                    acctyp = "DB-FOG";
                    act2 = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getAct().getPts().getPtyinr(), setmodVo.getSetamt() );
                    cdtKey =setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act2, "" );
                }
            }
            else
            {
                //D: 114(或116)外币
                if( ptsptaToolComponent.IsDemestic( fxdgrp.getApl()) )
                {
                    acctyp = "DB-CLR";
                    act1 = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getApl().getPts().getPtyinr(), setmodVo.getSetamt() );
                    cdtKey =setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act1, "" );
                }
                else
                {
                    acctyp = "DB-FOG";
                    act2 = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), fxdgrp.getApl().getPts().getPtyinr(), setmodVo.getSetamt() );
                    cdtKey =setglgService.setglgAddAmount ( setglg,"TRN", "APL", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "DBD", "C", act2, "" );
                }
            }
            //C:13903外币
            /**
             $Act2 = SETMOD\\GLEMOD.GetAvailAcc ( "FT-FXR", SETMOD\\DOCCUR, "", self, SETMOD\\SETAMT )

             **/
            act2 = glemodService.getAvailAcc ( "FT-FCR", setmodVo.getDoccur(), "", setmodVo.getSetamt() );
            cdtKey = setglgService.setglgAddAmount ( setglg,"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "FTC", "C", act2, "" );
            
            //D:281114 CNY 自营
            act5 = glemodService.getAvailAcc ( "FX-ZJJ", "CNY", "", setmodVo.getSetamt() );
            dbtKey =setglgService.setglgAddAmount ( setglg,"TRN1", "OWN", "CNY", fxdgrp.getCbs().getNom1().getAmt(), "", "FTD", "C", act5, "" );
            
            act4 = glemodService.getAvailAcc ( "FX-SLQ", "CNY", "", setmodVo.getSetamt() );
            dbtKey2 =setglgService.setglgAddAmount ( setglg,"TRN", "OWN", fxdgrp.getCbs().getNom1().getCur(), fxdgrp.getCbs().getNom1().getAmt().negate(), "", "FTC", "F", act4, "" );
        }
        setmodService.setglgAllValDat ( setmodVo,fxdgrp.getRec().getValdat(), "D" );

    }

    public String getAccountByEntity(){
        //#!根据实体获取结售汇平盘相关账号
        String etyExtkey=SettleContext.getUserEty().getExtkey();
        switch (etyExtkey){
            case "HCJB":
                return "140010122000224093";
            case "HRCB":
                return "6799901262116000010054";
            default:
                return "";
        }
    }

}
