package com.brilliance.isc.funds.fxtlop.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.fxtlop.service.impl.FxtlopTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FxtlopStructMapper;
import com.brilliance.isc.funds.vo.funds.FxtlopStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtssbStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FxtlopResource
 * @description: 结售汇平盘登记 Fxtlop 请求入口
 * @author: wangweidong
 * @create: 2024-10-08 16:34
 */
@RestController
@RequestMapping("/fxtlop")
@Api("结售汇平盘登记")
public class FxtlopResource extends AbstractTransactionController<FxtlopStoreVo> {

    @Resource
    private FxtlopStructMapper fxtlopStructMapper;

    public IStructMapper getStructMapper() {
        return fxtlopStructMapper;
    }

    @Resource(name = "fxtlop.transaction")
    FxtlopTransactionServiceImpl fxtlopTransactionService;

    @Autowired
    private SettleContext settleContext;

    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody FxtlopStoreVo fxtlopStoreVo) {
        String ref = fxtlopTransactionService.getRef(fxtlopStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }

    @PostMapping("/defaultRateN1000")
    public ResponseSet defaultRateN1000(@RequestBody FxtlopStoreVo fxtlopStoreVo) {
        try {
            settleContext.loadSettleSession("FXTLOP","","");
            fxtlopTransactionService.defaultRateN1000(fxtlopStoreVo);
            return ResponseSet.simpleSuccess(fxtlopStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }

    @PostMapping("/defaultCalculateN1100")
    public ResponseSet defaultCalculateN1100(@RequestBody FxtlopStoreVo fxtlopStoreVo) {
        try {
            settleContext.loadSettleSession("FXTLOP","","");
            fxtlopTransactionService.defaultCalculateN1100(fxtlopStoreVo);
            return ResponseSet.simpleSuccess(fxtlopStoreVo);
        } catch (Exception e) {
            throw e;
        } finally {
            SettleContext.removeUserSession();
        }

    }

}
