package com.brilliance.isc.funds.fxtlop.service.impl;

import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.fxtlop.service.FxtlopService;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.slf4j.Logger;

@Service
public class FxtlopServiceImpl implements FxtlopService {

    @Autowired
    XrtmodService xrtmodService;

    private static final Logger logger = LoggerFactory.getLogger(FxtlopServiceImpl.class);

    @Override
    public void initFxtlop(FxtlopStoreBo fxtlopStoreBo) {
        initFxtlop950(fxtlopStoreBo);
        initFxtlop1000(fxtlopStoreBo);
    }

    private void initFxtlop950(FxtlopStoreBo fxtlopStoreBo) {
    }

    private void initFxtlop1000(FxtlopStoreBo fxtlopStoreBo) {
        fxtlopStoreBo.getFxdgrp().getCbs().getNom1().setCur(xrtmodService.sysiso());
        // 成交日
        if( MdaUtils.isEmpty(fxtlopStoreBo.getFxdgrp().getRec().getOpndat()) || (!fxtlopStoreBo.getFxdgrp().getRec().isModified("opndat")) )
        {
            fxtlopStoreBo.getFxdgrp().getRec().setOpndat(  Dates.today());
            fxtlopStoreBo.getFxdgrp().getRec().resetModified("opndat");
        }
        //  起息日
        if( !fxtlopStoreBo.getFxdgrp().getRec().isModified("valdat") )
        {
            fxtlopStoreBo.getFxdgrp().getRec().setValdat(  fxtlopStoreBo.getFxdgrp().getRec().getOpndat());
        }
        String extkey = SettleContext.getUserSession().getUsr().getExtkey();
        fxtlopStoreBo.getFxdgrp().getRec().setUsr(extkey);
        fxtlopStoreBo.getFxtp().setFrgchk("X");
    }
}
