package com.brilliance.isc.funds.fxtsel.service.impl;

import com.brilliance.isc.bo.Trn;
import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.funds.bo.funds.FxtfopStoreBo;
import com.brilliance.isc.funds.common.component.FxToolComponent;
import com.brilliance.isc.funds.fxtsel.service.FxtselService;
import com.brilliance.isc.mda.dao.FxdMapper;
import com.brilliance.isc.mda.dao.TrnMapper;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.TrncodVo;
import com.brilliance.isc.vo.funds.FxdWithPtsCbbResponseVo;
import com.brilliance.isc.vo.funds.FxtselQueryVo;
import com.brilliance.mda.runtime.mda.util.Strings;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

//import com.brilliance.isc.funds.bo.Fxdgrp;

@Service
public class FxtselServiceImpl implements FxtselService {

    private Logger logger = LoggerFactory.getLogger(FxtselServiceImpl.class);

    @Autowired
    private FxdMapper fxdMapper;

    @Resource
    private TrnMapper trnMapper;

    @Resource
    private SysmodService sysmodService;

    @Autowired
    private FxToolComponent fxToolComponent;

    @Override
    public PageInfo list(FxtselQueryVo fxtselQueryVo) {
        PageHelper.startPage(fxtselQueryVo.getPageNumber(), fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public PageInfo listjshpp(FxtselQueryVo fxtselQueryVo) {
        //FB+FS
        List<String> fxtypList = new ArrayList<>();
        fxtypList.add("LB");
        fxtypList.add("LS");
        fxtselQueryVo.setFxtypList(fxtypList);
        PageHelper.startPage(fxtselQueryVo.getPageNumber(), fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public PageInfo listdhpp(FxtselQueryVo fxtselQueryVo) {
        //FB+FS
        List<String> fxtypList = new ArrayList<>();
        fxtypList.add("FB");
        fxtypList.add("FS");
        fxtselQueryVo.setFxtypList(fxtypList);
        PageHelper.startPage(fxtselQueryVo.getPageNumber(), fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public PageInfo listjsh(FxtselQueryVo fxtselQueryVo) {
        //FB+FS
        List<String> fxtypList = new ArrayList<>();
        fxtypList.add("SS");
        fxtypList.add("SB");
        fxtselQueryVo.setFxtypList(fxtypList);
        PageHelper.startPage(fxtselQueryVo.getPageNumber(), fxtselQueryVo.getPageSize()).setReasonable(true);
        List<FxdWithPtsCbbResponseVo> fxdList = fxdMapper.queryFxd(fxtselQueryVo);
        return new PageInfo(fxdList);
    }

    @Override
    public List<TrncodVo> dealWithByInr(TrnCodeQueryVo trnCodeQueryVo) {
        String type = Strings.toUpper(trnCodeQueryVo.getType());
        String inr = trnCodeQueryVo.getInr();
        if ("JSH".equals(type)) {
            //结售汇页签
            return jshDealWithByInr(inr);
        }
        List<TrncodVo> result = Lists.newArrayList();
        Fxdgrp fxdgrp = fxToolComponent.getFxdgrpByInr(inr);
        if ("DHPP".equals(type)) {
            String[] fxTraArray = {"FXTFCM", "FXTFCN"};
            String[] fxButArray = {"外币兑换平盘确认", "外币兑换平盘销账"};
            String isAllowed = "";
            for (int i = 0; i < fxTraArray.length; i++) {
                TrncodVo trncodVo = new TrncodVo(fxTraArray[i], fxButArray[i], isAllowed, "Y", "");
                fxToolComponent.isFXTrnAllowed(fxdgrp, trncodVo);
                result.add(trncodVo);
            }
        } else if ("JSHPP".equals(type)) {
            String[] fxTraArray = {"FXTLCM", "FXTLCN"};
            String[] fxButArray = {"结售汇平盘确认", "结售汇平盘销账"};
            String isAllowed = "";
            for (int i = 0; i < fxTraArray.length; i++) {
                TrncodVo trncodVo = new TrncodVo(fxTraArray[i], fxButArray[i], isAllowed, "Y", "");
                fxToolComponent.isFXTrnAllowed(fxdgrp, trncodVo);
                result.add(trncodVo);
            }
        }
        return result;
    }


    @Override
    public Object selectXxdByPrimaryKey(Map<String, String> map) {
        String objinr = map.get("objinr");
        String objtyp = map.get("objtyp");
        String pntinr = map.get("pntinr");
        FxtfopStoreBo fxtfopStoreBo = new FxtfopStoreBo();
        fxtfopStoreBo.reset();
        if (objinr.length() == 16) {
            Trn trnLid = trnMapper.selectByObjinrTrn(objtyp, objinr, "FXTFOP");
            if (!Objects.isNull(trnLid)) {
                fxtfopStoreBo = sysmodService.streamGetNameInSubDir(FxtfopStoreBo.class, trnLid.getInr());
            }
        }
        fxtfopStoreBo.setFxdgrp(fxToolComponent.getFxdgrpByInr(objinr));
        return fxtfopStoreBo;


    }

    @Override
    public List<TrncodVo> jshDealWithByInr(String inr) {
        List<TrncodVo> result = Lists.newArrayList();
        Fxdgrp fxdgrp = fxToolComponent.getFxdgrpByInr(inr);
        String[] fxTraArray = {"FXTSQO"};
        String[] fxButArray = {"结售汇报价"};
        String isAllowed = "";
        for (int i = 0; i < fxTraArray.length; i++) {
            TrncodVo trncodVo = new TrncodVo(fxTraArray[i], fxButArray[i], isAllowed, "Y", "");
            fxToolComponent.isFXTrnAllowed2(fxdgrp, trncodVo);
            result.add(trncodVo);
        }
        return result;
    }
}
