package com.brilliance.isc.funds.transfer.transaction;

import com.brilliance.isc.funds.bo.funds.FxtlcnStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtlcnStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

/**
 * @program: isc-funds
 * @ClassName: FxtlcnStructMapper
 * @description:
 * @author: xiaotong
 * @create: 2024-10-11 17:17
 */
@Mapper(componentModel = "spring")
public interface FxtlcnStructMapper extends IBaseStructMapper<FxtlcnStoreBo, FxtlcnStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtlcnStructMapper INSTANCE = Mappers.getMapper(FxtlcnStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FxtlcnStoreBo voTransferToBo(FxtlcnStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FxtlcnStoreVo vo, @MappingTarget FxtlcnStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FxtlcnStoreVo boTransferToVo(FxtlcnStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FxtlcnStoreBo bo, @MappingTarget FxtlcnStoreVo vo);
}
